#!/bin/bash

set -xe

MODE=$1
x=$(sudo docker container ls | grep next-js | wc -l)
if [ $x -eq 1 ]; then
    sudo MODE=$MODE docker-compose rm -sf
fi

sudo MODE=$MODE docker-compose build

if [ ! -d "./src/powerpanel" ]; then
    sudo MODE=$MODE docker-compose run powerpanel-webview npx create-next-app powerpanel
    sudo chown -R $USER:$USER ./src
    sudo MODE=$MODE docker-compose run powerpanel-webview npx next telemetry disable
fi

if [ $MODE == "dev" ] || [ $MODE == "start" ]; then
    sudo MODE=$MODE docker-compose up --build --force-recreate --remove-orphans -d
    sudo MODE=$MODE docker-compose logs -f
elif [ $MODE == "build" ]; then
    sudo MODE=$MODE docker-compose run powerpanel-webview bash -c "cd powerpanel && npm install"
    sudo MODE=$MODE docker-compose run powerpanel-webview bash -c "cd powerpanel && npm run build"
else
    echo "Please use 'dev', 'build', or 'start' as an argument."
    exit 1
fi
